# Interfaces and dependencies

A non-exhaustive list of required interfaces and necessary dependencies within the project.

## Interfaces

Equation interface:
- ?

Implementation/Discretization interface:
- compute_rhs!
- register_variables!
- equation
- mesh
- timestep
- variables
- maximum_speed

HRSC interface:
- indicator
- compute_indicator!
- ArtficialViscosity
  - viscosity
  - compute_viscosity!
- Reconstruction
  - weights
  - compute_weights!
  - reconstruct!
- callback
- register_variables!

Indicator interface:
- SmoothnessIndicator
  - weights
  - compute_weights!
- TroubledCellIndicator
  - cellindices
  - compute_cellindices!
- callback
- register_variables!

Bdryconditions interface:
- 

Callback interface:
- (::AbstractCallback)(u, t, iter)
  - FunctionCallback
  - PlotCallback
  - SaveCallback
- (maybe?) priority
- schedule/timing

- Special interfaces:
  - EntropyViscosity
    requires entropy!, entropyflux! functions

=====

## Dependencies

# To be implemented in a project

- compute_rhs!
  - HRSC interface (viscosity/weights+reconstruct)
  - Equation interface
  - Implementation interface (mesh, variables)

- timestep
  - Implementation interface (mesh, maximum_speed)
  - Equation interface
  - HRSC interface (viscosity)

- HRSC.callback

- Indicator.callback

- maximum_speed
  - Implementation interface (mesh, variables)
  - Equation interface

# To be implemented in dg1d

- compute_indicator!
  - Indicator interface (compute_weights/compute_cellindices)
  - Implementation interface (mesh, variables)

- compute_weights!/compute_viscosity!
  - Indicator interface
  - Implementation interface (mesh, variables)

- variables
  - ???

- reconstruct!
  - Implementation interface (mesh)
