mutable struct Equation{T_EoS<:AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
  cold_eos::Polytrope
  atm_density::Float64
  atm_factor::Float64
  atm_threshold::Float64
  c2p_threshold_velocity_limiter::Float64
  c2p_set_atmosphere_on_failure::Bool
end


struct Project{Formulation,
               T_Eq    <:AbstractEquation,
               T_HRSC  <:Maybe{HRSC.AbstractHRSC},
               T_TCI   <:Maybe{TCI.AbstractTCI},
               T_Prms}
  equation::T_Eq
  hrsc::T_HRSC
  tci::T_TCI
  prms::T_Prms
  prmsdb::dg1d.ParameterDB
end
Project(formulation, fields...) = Project{formulation,typeof.(fields[1:end-1])...}(fields...)


formulation(::Project{F}) where F = F
