"""
    TCIViscosity

Generic Artificial Viscosity method based on any troulbed cell indicator.
"""
Base.@kwdef struct TCIViscosity{T_Mesh<:Mesh} <: AbstractArtificialViscosity
  mesh::T_Mesh
  mu_threshold::Float64
  mu_max::Float64
end


function compute_viscosity!(
    mu,
    flag,
    av::TCIViscosity)

  @unpack mesh, mu_threshold, mu_max = av

  for k = 1:length(mesh.tree.cells)
    muk = flag[k] * mu_max
    if muk < mu_threshold
      muk = 0
    end
    mu[k] = muk
  end

  return true
end
