@with_signature [simd=false] function cons2prim_kastaun(equation::AbstractEquation)
  @accepts D, S, tau, x
  prms = (; eos=equation.eos, atm_density=1e-10, atm_threshold=100.0,
            c2p_threshold_velocity_limiter=-1.0 #=disable limiter=#,
            c2p_set_atmosphere_on_failure=equation.c2p_set_atmosphere_on_failure,
            cold_eos=equation.cold_eos)
  D, S, _, tau, rho, v, _, _, eps, p, _, _, _, _, _, _ =
    GRHD.cons2prim_impl(prms.eos, prms.cold_eos, prms,
                        D, #=Sx=#S, #=Sz=#0.0, tau,
                        x, #=z=#0.0, #=γxx=#1.0, #=γzz=#1.0,
                        #=c2p_reset/limit/freeze=# 0.0, 0.0, 0.0)
  @returns D, S, tau, rho, v, eps, p
end
