Base.@kwdef struct Atmosphere
  rho::Float64
  threshold::Float64
end


struct Equation{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
  cold_eos::Polytrope
  atmosphere::Atmosphere
  c2p_set_atmosphere_on_failure::Bool
end


struct Equation2d{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
  cold_eos::Polytrope
  atmosphere::Atmosphere
  c2p_set_atmosphere_on_failure::Bool
end


struct Project{T_Eq <: AbstractEquation,
               T_HRSC     <:Maybe{HRSC.AbstractHRSC},
               T_TCI      <:Maybe{TCI.AbstractTCI},
               T_Prms}

  equation::T_Eq
  hrsc::T_HRSC
  tci::T_TCI
  prms::T_Prms
end


struct Project2d{Eq<:Equation2d,
                 T_HRSC<:Maybe{HRSC.AbstractHRSC},
                 T_BC<:dg1d.AbstractBC}
  equation::Eq
  hrsc::T_HRSC
  bdrycond::T_BC
end
