@testset "Workspace" begin

  ws = dg1d.Workspace()
  @test isempty(ws.chunks)

  dg1d.enter(ws) do
    v1 = dg1d.borrow(ws, 1)
    v2 = dg1d.borrow(ws, 2)
    v3 = dg1d.borrow(ws, 3)
    @test length(v1) == 1
    @test length(v2) == 2
    @test length(v3) == 3
    v4 = dg1d.borrow(ws, 1)
    v5 = dg1d.borrow(ws, 2)
    v6 = dg1d.borrow(ws, 3)
    @test length(v4) == 1
    @test length(v5) == 2
    @test length(v6) == 3
  end

  @test length(ws.chunks) == 3
  for chk in values(ws.chunks)
    @test length(chk.arrays) == 2
  end

  dg1d.enter(ws) do
    v1 = dg1d.borrow(ws, 1)
    v2 = dg1d.borrow(ws, 2)
    v3 = dg1d.borrow(ws, 3)
    @test length(v1) == 1
    @test length(v2) == 2
    @test length(v3) == 3
  end

  @test length(ws.chunks) == 3
  for chk in values(ws.chunks)
    @test length(chk.arrays) == 2
  end

  @test_throws ErrorException dg1d.borrow(ws, 1)
  dg1d.enter(ws) do
    @test_throws ErrorException dg1d.enter(ws) do
      println("sers")
    end
  end

end
