using Coverage
using Printf

cd(joinpath(@__DIR__, "..", "..")) do
  processed_coverage = process_folder()
  exclude_patterns = [ r"src/.*/.*" #= ignore files in sub directories like src/HRSC/.* =# ]
  for pattern in exclude_patterns
    filter!(cvg -> isnothing(match(pattern, cvg.filename)), processed_coverage)
  end
  covered_lines, total_lines = get_summary(processed_coverage)
  percentage = covered_lines / total_lines * 100
  @printf "Code coverage: %.2f%% of lines covered" percentage
end
